function [x_calc, y_calc, elevation] = backwater(y0,xend, Q0,channel ,varargin)
% [x_calc, y_calc, elevation] = backwater(y0,xend,Q0,canal,varargin)
% ej de uso
%  channel = struct('tipo',1,'param',2.3,'alfa',1,'beta',1,'n',0.011,'Is',0.001);
%  channel=defineseccion(channel);
%   [x,y] = backwater(2,240,5.2,channel)
% canal puede ser una estructura con o un vector:
% ej.:
%  SOLO IMPLEMENTADO COMO ESTRUCTURA!!!
% channel = [tipocanal parametroscanal n Is (alfa) (beta)] alfa y beta pueden omitirse
% o estructura con campos tipo, param, n, Is, alfa y beta; 
%  y function handlers a su area, Rh y anchosl en función del calado en cuyo
% caso no se emplea el tipo de canal
%  channel = struct('tipo',1,'param',2.3,'alfa',1,'beta',1,'n',0.011,'Is',0.001);
%  channel=defineseccion(canal);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% varargin puede contener la estructura para FEV qast  o 
% no contenerla en cuyo caso se presupone Q cte (FGV)
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Curvas de remanso / backwater calculation
% Licencia GPLv3 https://www.gnu.org/licenses/gpl-3.0.txt
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Output / Salidas
% x_calc, y_calc (depth/calado), elevation
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  if isstruct ( channel ),
    canal = channel;
  else
    % SIN IMPLEMENTAR
%    canal = struct('tipo',channel(1),'param',channel(2),'alfa',alfa,'beta',beta,'n',channel(3),'Is', channel(4));
%   canal=defineseccion(canal);
  end

  if canal.tipo~=6,
    y0c=caladocritico ([0.01 20], Q0, canal);
    y0n=caladonormal([0.01 20],Q0,canal);
  else
    y0c=caladocritico ([0.01 canal.param-1e-3], Q0, canal);
    y0n=caladonormal([0.01 canal.param-1e-3],Q0,canal);
  end
  
  parametros_definidos=2;

  salida_grafica = 0;

  if nargin == 5,
    qast = varargin{1};
  end
  
  script_calculo_remanso;


  
